from inspect import modulesbyfile
from time import time
from pymavlink import mavutil
import time
# Import common module for MAVLink 2

# co the dung mission planner ket noi port udp 127.0.0.1:14550 de quan sat
mydrone = mavutil.mavlink_connection('udpin:127.0.0.1:14551')

def log(vehicle):
    msg = vehicle.recv_match(type="COMMAND_ACK", blocking = True)
    print(msg)

# Wait for the first heartbeat 
mydrone.wait_heartbeat()
print("Heartbeat from system (system %u component %u)" % (mydrone.target_system, mydrone.target_component))


#armed force
mydrone.mav.command_long_send(mydrone.target_system, mydrone.target_component, mavutil.mavlink.MAV_CMD_COMPONENT_ARM_DISARM,0,1,21196,0,0,0,0,0)
log(mydrone)
time.sleep(10)

#takeoff
mydrone.mav.command_long_send(0, 0, mavutil.mavlink.MAV_CMD_NAV_TAKEOFF,
                                               0, 0, 0, 0, 0, 0, 0, 10)
log(mydrone)
time.sleep(15)



#waypoint 1
mydrone.mav.mission_item_send(0, 0, 0, mavutil.mavlink.MAV_FRAME_GLOBAL_TERRAIN_ALT,
                                           mavutil.mavlink.MAV_CMD_NAV_WAYPOINT, 2, 0, 0,
                                           0, 0, 0, -35.3630860, 149.1652045,
                                           10)
time.sleep(20)
print("Waypoint 1 finished")

#waypoint 2
mydrone.mav.mission_item_send(0, 0, 0, mavutil.mavlink.MAV_FRAME_GLOBAL_TERRAIN_ALT,
                                           mavutil.mavlink.MAV_CMD_NAV_WAYPOINT, 2, 0, 0,
                                           0, 0, 0, -35.3630477, 149.1656256,
                                           10)
log(mydrone)
time.sleep(30)

print("Waypoint 2 finished")
